import {
    world,
    system
} from '@minecraft/server';

world.afterEvents.itemStartUse.subscribe(event => {
    const player = event.source;
    const item = event.itemStack;

    if (item.typeId === "nd:terminus") {
        player.runCommand("/execute unless entity @e[type=nd:nameless_deity,r=100] run stopsound @a music.nd.edenic_whispers");
        player.runCommand("/execute unless entity @e[type=nd:nameless_deity,r=100] run summon nd:terminus ^ ^1 ^4 facing @s");
    };

    // Budget Charm

    if (item.typeId === "nd:budget_charm") {
        player.runCommand("/execute if entity @a[tag=budget] run tag @s add no_budget");
        player.runCommand(`/execute if entity @a[tag=budget] run tellraw @a {"rawtext":[{"text":"§4Budget Mode Disabled"}]}`);
        player.runCommand("/execute if entity @a[tag=budget] run playsound note.bell @s ^ ^ ^ 0.5 0.75");
        player.runCommand("/execute if entity @a[tag=budget] run tag @a remove budget");
        player.runCommand("/execute unless entity @a[tag=no_budget] run tag @s add budget");
        player.runCommand(`/execute unless entity @a[tag=no_budget] run tellraw @a {"rawtext":[{"text":"§aBudget Mode Enabled"}]}`);
        player.runCommand("/execute unless entity @a[tag=no_budget] run playsound note.bell @s ^ ^ ^ 0.5 1.5");
    };
});

world.afterEvents.entityHurt.subscribe(event => {
    const damage = event.damage
    const source = event.damageSource
    const target = event.hurtEntity

    if (target && damage >= 40 && target.typeId === "nd:nameless_deity" && source.cause != "void") {
        target.runCommand(`/event entity @s nd:become_enraged`);
    }
})

system.afterEvents.scriptEventReceive.subscribe(event => {
    const message = event.message
    const target = event.sourceEntity

    for (const player of world.getPlayers()) {
        const platform = player.clientSystemInfo.platformType
        if (message === "input_test") {
            if (platform === "Mobile") {
                target.runCommand(`/tellraw @s {"rawtext":[{"text":"<P1xtinum's Nameless Deity Addon> §7You are currently using a mobile device. If you experience slowdowns or lag during the fight, you may need to activate the 'Budget Charm' item to improve performance."}]}`);
            }
            if (platform === "Console") {
                target.runCommand(`/tellraw @s {"rawtext":[{"text":"<P1xtinum's Nameless Deity Addon> §7You are currently using a console. If you experience slowdowns or lag during the fight, you may need to activate the 'Budget Charm' item to improve performance."}]}`);
            }
        }
    }
})